<project xmlns="http://maven.apache.org/POM/4.0.0"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>
	<parent>
		<artifactId>maven-parent</artifactId>
		<groupId>org.gcube.tools</groupId>
		<version>1.2.0</version>
	</parent>
	<groupId>org.gcube.application.cms</groupId>
	<artifactId>gcube-cms-suite</artifactId>
	<packaging>pom</packaging>
	<version>1.0.5</version>
	<name>Gcube CMS Suite</name>

	<description>gCube CMS Suite is a set of components designed to manage complex space-temporal Documents defined by metadata Profiles.</description>

	<properties>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<geotools.version>8.0-M4</geotools.version>
		<geoAPI-version>3.0.1</geoAPI-version>
		<distroDirectory>distro</distroDirectory>
		<gitBaseUrl>https://code-repo.d4science.org/gCubeSystem</gitBaseUrl>

		<!-- default is prod -->
		<gcube-bom-version>2.3.0</gcube-bom-version>
		<gcube-smartgears-bom-version>2.4.0</gcube-smartgears-bom-version>
		<gcube-portal-bom-version>3.7.0</gcube-portal-bom-version>
		<storagehub-version-range>[1.0.0,2.0.0-SNAPSHOT)</storagehub-version-range>
		<plugin-framework-version>1.0.4</plugin-framework-version>
		
		<!--dev -->
		<!-- <gcube-bom-version>2.1.0-SNAPSHOT</gcube-bom-version> -->
		<!-- <gcube-smartgears-bom-version>2.2.0-SNAPSHOT</gcube-smartgears-bom-version> -->
		<!-- <gcube-portal-bom-version>3.7.0-SNAPSHOT</gcube-portal-bom-version> -->
		<!-- <storagehub-version-range>[2.0.0-SNAPSHOT,3.0.0-SNAPSHOT)</storagehub-version-range> -->

	</properties>

	<profiles>
		<!-- PROD profile -->
		<profile>
			<id>geoportal-release-profile</id>
			<activation>
				<property>
					<name>Release</name>
				</property>
			</activation>
			<properties>
				<gcube-bom-version>2.3.0</gcube-bom-version>
				<gcube-smartgears-bom-version>2.4.0</gcube-smartgears-bom-version>
				<gcube-portal-bom-version>3.7.0</gcube-portal-bom-version>
				<storagehub-version-range>[1.0.0,2.0.0-SNAPSHOT)</storagehub-version-range>
				<plugin-framework-version>1.0.4</plugin-framework-version>
			</properties>
		</profile>
		<!-- DEV profile -->
		<profile>
			<id>geoportal-snapshot-profile</id>
			<activation>
				<property>
					<name>!Release</name>
				</property>
			</activation>
			<properties>
				<gcube-bom-version>2.4.0-SNAPSHOT</gcube-bom-version>
				<gcube-smartgears-bom-version>2.2.0-SNAPSHOT</gcube-smartgears-bom-version>
				<gcube-portal-bom-version>3.7.0-SNAPSHOT</gcube-portal-bom-version>
				<storagehub-version-range>[2.0.0-SNAPSHOT,3.0.0-SNAPSHOT)</storagehub-version-range>
				<plugin-framework-version>1.0.4-SNAPSHOT</plugin-framework-version>
			</properties>
		</profile>
	</profiles>



	<scm>
		<connection>scm:git:${gitBaseUrl}/gcube-cms-suite</connection>
		<developerConnection>scm:git:${gitBaseUrl}/gcube-cms-suite</developerConnection>
		<url>${gitBaseUrl}/gcube-cms-suite</url>
	</scm>


	<modules>
		<!-- Main engine -->
		<module>geoportal-service</module>

		<!-- Common core modules -->
		<module>geoportal-common</module>
		<module>cms-plugin-framework</module>

		<!-- Client library -->
		<module>geoportal-client</module>


		<!-- Common Plugins -->
		<module>default-lc-managers</module>
		<module>sdi-plugins</module>
		<module>notifications-plugins</module>

		<!-- <module>dataminer-plugins</module> -->
		<!-- <module>images-plugin</module> -->
		<!-- <module>ckan-plugin</module> -->


		<!-- Custom implementations -->
		<module>concessioni-lifecycle</module>
		<module>concessioni-model</module>



		<!-- Utilities & tests -->
		<!-- <module>cms-test-commons</module> -->
		<!-- <module>use-cases</module> -->


	</modules>



	<dependencyManagement>
		<dependencies>
			<dependency>
				<groupId>org.gcube.distribution</groupId>
				<artifactId>gcube-bom</artifactId>
				<version>${gcube-bom-version}</version>
				<type>pom</type>
				<scope>import</scope>
			</dependency>

			<dependency>
				<groupId>org.gcube.distribution</groupId>
				<artifactId>gcube-smartgears-bom</artifactId>
				<version>${gcube-smartgears-bom-version}</version>
				<type>pom</type>
				<scope>import</scope>
			</dependency>


			<!-- modules -->
			<dependency>
				<groupId>org.gcube.application</groupId>
				<artifactId>geoportal-service</artifactId>
				<version>[1.0.6,2.0.0-SNAPSHOT)</version>
			</dependency>

			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>cms-plugin-framework</artifactId>
				<version>${plugin-framework-version}</version>
				<scope>provided</scope>
			</dependency>



			<!-- Common Plugins -->
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>default-lc-managers</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>sdi-plugins</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>notifications-plugins</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>dataminer-plugins</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>images-plugin</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>ckan-plugin</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>



			<!-- CLIENT -->
			<dependency>
				<groupId>org.gcube.application</groupId>
				<artifactId>geoportal-client</artifactId>
				<version>[1.0.5,2.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>geoportal-common</artifactId>
				<version>[1.0.7,2.0.0-SNAPSHOT)</version>
			</dependency>


			<!-- CUSTOM : CONCESSIONI -->

			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>concessioni-model</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>

			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>concessioni-lifecycle</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>


			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>cms-test-commons</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
				<scope>test</scope>
			</dependency>
			<dependency>
				<groupId>org.gcube.application.cms</groupId>
				<artifactId>use-cases</artifactId>
				<version>[1.0.0,2.0.0-SNAPSHOT)</version>
			</dependency>



			<dependency>
				<groupId>org.reflections</groupId>
				<artifactId>reflections</artifactId>
				<version>0.10.2</version>
			</dependency>


			<!-- JDK 11 -->
			<!-- NB versions introduced in gcube-bom 2.1.0 -->
			<dependency>
				<groupId>org.projectlombok</groupId>
				<artifactId>lombok</artifactId>
				<version>1.18.4</version>
			</dependency>

			<dependency>
				<groupId>javax.xml.bind</groupId>
				<artifactId>jaxb-api</artifactId>
				<version>2.4.0-b180830.0359</version>
			</dependency>

			<dependency>
				<groupId>com.sun.xml.bind</groupId>
				<artifactId>jaxb-impl</artifactId>
				<version>2.4.0-b180830.0438</version>
			</dependency>

			<!-- https://mvnrepository.com/artifact/org.glassfish.jaxb/jaxb-runtime -->
			<dependency>
				<groupId>org.glassfish.jaxb</groupId>
				<artifactId>jaxb-runtime</artifactId>
				<version>2.4.0-b180830.0438</version>
			</dependency>

			<dependency>
				<groupId>com.sun.xml.bind</groupId>
				<artifactId>jaxb-core</artifactId>
				<version>2.3.0.1</version>
			</dependency>


			<!-- https://mvnrepository.com/artifact/com.sun.istack/istack-commons-runtime -->
			<dependency>
				<groupId>com.sun.istack</groupId>
				<artifactId>istack-commons-runtime</artifactId>
				<version>2.4</version>
			</dependency>


			<dependency>
				<groupId>javax.activation</groupId>
				<artifactId>activation</artifactId>
				<version>1.1.1</version>
			</dependency>


			<dependency>
				<groupId>junit</groupId>
				<artifactId>junit</artifactId>
				<version>4.11</version>
			</dependency>


			<!-- STORAGE -->
			<dependency>
				<groupId>org.gcube.contentmanagement</groupId>
				<artifactId>storage-manager-core</artifactId>
				<version>[2.0.0, 3.0.0-SNAPSHOT)</version>
			</dependency>
			<dependency>
				<groupId>org.gcube.contentmanagement</groupId>
				<artifactId>storage-manager-wrapper</artifactId>
				<version>[2.0.0, 3.0.0-SNAPSHOT)</version>
			</dependency>

			<dependency>
				<groupId>org.gcube.common</groupId>
				<artifactId>storagehub-client-library</artifactId>
				<version>${storagehub-version-range}</version>
			</dependency>


			<!-- Serialization -->
			<dependency>
				<groupId>com.fasterxml.jackson.datatype</groupId>
				<artifactId>jackson-datatype-jsr310</artifactId>
				<version>2.8.8</version>
			</dependency>
		</dependencies>
	</dependencyManagement>




	<build>
		<pluginManagement>
			<plugins>
				<plugin>
					<groupId>org.eclipse.m2e</groupId>
					<artifactId>lifecycle-mapping</artifactId>
					<version>1.0.0</version>
					<configuration>
						<lifecycleMappingMetadata>
							<pluginExecutions>
								<pluginExecution>
									<pluginExecutionFilter>
										<groupId>org.codehaus.mojo</groupId>
										<artifactId>flatten-maven-plugin</artifactId>
										<versionRange>[1.0.0,)</versionRange>
										<goals>
											<goal>flatten</goal>
										</goals>
									</pluginExecutionFilter>
									<action>
										<execute>
											<runOnIncremental>false</runOnIncremental>
										</execute>
									</action>
								</pluginExecution>
							</pluginExecutions>
						</lifecycleMappingMetadata>
					</configuration>
				</plugin>
			</plugins>
		</pluginManagement>
		<plugins>
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>flatten-maven-plugin</artifactId>
				<version>1.0.1</version>
				<configuration>
					<updatePomFile>true</updatePomFile>
					<outputDirectory>target</outputDirectory>
				</configuration>
				<executions>
					<execution>
						<id>flatten</id>
						<phase>process-resources</phase>
						<goals>
							<goal>flatten</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
		</plugins>
	</build>
</project>